class A {
    private int f() { return 1; }
    public int f(int x) { return f() + 1; }
  }
  class B extends A {
    public int f(boolean x ) { return 3; }
    public int f(double x ) { return f(true) + 1; }
    public int f(int x, double y) { return 3; }
    public int f(double x, int y) { return 7; }
  }

  class C extends B {
    public int f(boolean x ) { return 5; }
    public int f(int x ) { return 6; }
  }

  public class Esempio4 {
    public static void main(String[ ] args) {
      B beta = new C();
      System.out.println(beta.f(1));
      //System.out.println(beta.f(2, 1));
    }
  }

  /**
   * Per la chiamata al metodo beta.f(1):
   * 
   * Early Binding. 
   * Fase 1: partiamo dal tipo dichiarato della variabile beta, quindi dalla classe B 
   * e cerchiamo in questa classe tutte le interfacce compatibili con la firma (int) 
   * chiedendoci se int è compatibile con l'interfaccia dei metodi incontrati. 
   * In B troviamo la firma (boolean) che non risulta compatibile e la 
   * firma (double) che risulta compatibile. 
   * Infine anche le firme (int, double) e (double, int) non sono compatibili. 
   * In A avremo che la firma senza argomenti () non può essere utilizzata, 
   * al contrario la firma (int) risulta compatibile. 
   * Quindi abbiamo f(double x) in B e f(int x) in A.
   * 
   * Fase 2: dobbiamo individuare la firma più specifica tra tutte le firme candidate: 
   * f(int x) in A.
   * 
   * Late Binding. 
   * Abbiamo in ingresso la firma (int) e a partire dal tipo effettivo (dinamico) della variabile beta, 
   * quindi dalla classe C (perché B beta = new C();), cerchiamo il primo metodo con esattamente la stessa 
   * firma di quella cercata. 
   * Il primo metodo individuato con firma (int) si trova in C e il risultato che verrà stampato sullo 
   * schermo sarà il numero 6.
   */